<!DOCTYPE html>
<html lang="en">

<head>
    <title> APIs sample cho Course365 Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .divider {
        border-bottom: 2px solid #0163ee;
        margin-top: 2rem;
        margin-bottom: 2rem;
        width: 23rem;
    }
</style>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";

    /********** API FOR COURSE365 PROJECT ***********/

    // API lấy danh sách courses (all courses)
    function onGetCoursesListClick() {
        var vAPI_URL = gBASE_URL + "/courses";
        var vXhttp = new XMLHttpRequest();
        vXhttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXhttp.responseText); // ghi response text ra console.log
            }
        };
        vXhttp.open("GET", vAPI_URL, true);
        vXhttp.send();
    }

    // API lấy chi tiết 01 course  by id
    function onGetCourseByIdClick() {
        const vAPI_URL = gBASE_URL + "/courses/";
        var vCourseId = 21;

        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + vCourseId, true);
        vXmlHttp.send();
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
            }
        }
    }

    // API tạo (Create) một course mới
    function onCreateCourseClick() {
        const vAPI_URL = gBASE_URL + "/courses";
        // đối tượng course sẽ được tạo mới
        var vCourseObjRequest = {
            courseCode: "BE_WEB_JAVA_101",
            courseName: "Java for Beginer",
            price: 550,
            discountPrice: 400,
            duration: "3h 56m",
            level: "Beginner",
            coverImage: "images/courses/course-java.jpg",
            teacherName: "Morris Mccoy",
            teacherPhoto: "images/teacher/morris_mccoy.jpg",
            isPopular: false,
            isTrending: false
        };
        
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("POST", vAPI_URL, true);
        vXmlHttp.setRequestHeader("Content-Type", "application/json");
        vXmlHttp.send(JSON.stringify(vCourseObjRequest));
        
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_OK) {
                console.log(vXmlHttp.responseText);
            }
        }
    }

    // API để sửa (update) một course theo Id
    function onUpdateCourseClick() {
        const vAPI_URL = gBASE_URL + "/courses/";
        // id course cần sửa
        var vCourseId = 21;
        // đối tượng course sẽ được sửa
        var vCourseObjRequest = {
            courseCode: "BE_WEB_JAVA_101",
            courseName: "Java for Beginer",
            price: 550,
            discountPrice: 410,
            duration: "3h 56m",
            level: "Beginner",
            coverImage: "images/courses/course-java.jpg",
            teacherName: "Morris Mccoy",
            teacherPhoto: "images/teacher/morris_mccoy.jpg",
            isPopular: false,
            isTrending: false
        };

        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("PUT", vAPI_URL + vCourseId, true);
        vXmlHttp.setRequestHeader("Content-Type", "application/json");
        vXmlHttp.send(JSON.stringify(vCourseObjRequest));

        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
            }
        }
    }

    // API để xóa (delete) một course theo Id
    function onDeleteCourseClick() {
        const vAPI_URL = gBASE_URL + "/courses/";
        // id course sẽ xóa
        var vCourseId = 15;
        
        var vXmlhttp = new XMLHttpRequest();
        vXmlhttp.open("DELETE", vAPI_URL + vCourseId, true);
        vXmlhttp.send();

        vXmlhttp.onreadystatechange = function() {
            // xóa thành công course
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log("Delete course id = " + vCourseId + " thành công!");
            }
        }
    }

</script>

<body>
    <div class="container mt-4">
        <div class="row form-group">
            <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
        </div>
        <div class="row form-group">
            <p id="testP" class="h4"> Demo 05 API cho dự án Course365: </p>
        </div>
        <div class="row form-group">
            <button  class="btn btn-info m-1" onclick="onGetCoursesListClick()">Lấy danh sách Khóa học</button>
            <button  class="btn btn-warning m-1" onclick="onGetCourseByIdClick()">Lấy chi tiết 1 Khóa học theo Id</button>
            <button  class="btn btn-success m-1" onclick="onCreateCourseClick()">Tạo mới Khóa học (Create)</button>
            <button  class="btn btn-primary m-1" onclick="onUpdateCourseClick()">Sửa Khóa học (Update)</button>
            <button  class="btn btn-danger m-1" onclick="onDeleteCourseClick()">Xóa Khóa học (Delete)</button>
        </div>
    </div>
</body>

</html>